/**
 * @author ryucha
 */

winAddMoney.initialize = function(args){
	
	if (args.action == null) {
		txtMoneyPak.value = null;
		viewEnterMoneyPak.visible = true;
		viewCongratsAdd.visible = false;
		viewConfirmAdd.visible = false;
	} else if (args.action == "validate") {
		viewEnterMoneyPak.visible = false;
		viewCongratsAdd.visible = false;
		viewConfirmAdd.visible = true;
	} else if (args.action == "congrats") {
		viewConfirmAdd.visible = false;	
		viewEnterMoneyPak.visible = false;
		viewCongratsAdd.visible = true;
	}
	
	// Return control back to the redirect function
	//lblAccountBalanceAmt2.text = formatNegativeAmount(lblAccountBalanceBig.text);
	return true;
}

winAddMoney.addEventListener('android:back', function(e) {
	if (Titanium.Platform.name == 'iPhone OS') {
		txtMoneyPak.blur();
	}
	
	goBack();
});

if (Titanium.Platform.name == 'iPhone OS') {
	viewEnterMoneyPak.addEventListener('singletap', function(){
		txtMoneyPak.blur();
	});
} else if (Titanium.Platform.name == 'Android') {
	viewEnterMoneyPak.addEventListener('click', function(){
		Ti.UI.Android.hideSoftKeyboard();
	});
	
	viewPlainHeader.addEventListener('click', function(){
		Ti.UI.Android.hideSoftKeyboard();
	});
}
//go to add money
btnPlusMoney.addEventListener('click', function(){
	if (txtMoneyPak.value == null) {
		getAlert("MoneyPak number required.");
		return;
	}
	
	if (txtMoneyPak.value.length < 12 || IsNumeric(txtMoneyPak.value) == false) {
		getAlert("MoneyPak number required.");
		return;
	}
	txtMoneyPak.blur();
	Titanium.App.fireEvent('enterMoneyPakClick', {
    });
});

//confirming money add
btnYes.addEventListener('click', function(){
	Titanium.App.fireEvent('confirmYesClick', {
    });
});

//cancel money add
btnCancel.addEventListener('click', function(){
	Titanium.App.fireEvent('cancelAddClick', {
    });
});

//ok congrats!
btnOK.addEventListener('click', function(){
	Titanium.App.fireEvent('OKReturnClick', {
    });
});

btnBackButtonA.addEventListener('click', function() {
	if (Titanium.Platform.name == 'iPhone OS') {
		txtMoneyPak.blur();
	}
	goBack();
});

btnHomeButtonA.addEventListener('click', function() {
	if (Titanium.Platform.name == 'iPhone OS') {
		txtMoneyPak.blur();
	}
	goHome();
});

lblWhere.addEventListener('click', function(e) {
	redirect("reloadATMScreen", "initialize", {screenType:"retail"});
});

Titanium.App.addEventListener('enterMoneyPakClick', function(e){
	
	// GetMoneyPakBalance
	Titanium.App.fireEvent('GetMoneyPakBalance', {});	
}); 

Titanium.App.addEventListener('confirmYesClick', function(e){
	
	Titanium.App.fireEvent('ApplyMoneyPak', {});
});

Titanium.App.addEventListener('cancelAddClick', function(e){
	goBack();
});

Titanium.App.addEventListener('OKReturnClick', function(e){
	
	redirect("accountBalanceScreen", null, null);
});


Titanium.App.addEventListener('GetMoneyPakBalance', function(e){
    var strClientToken = Titanium.App.Properties.getString("User_" + txtUserId.value);

	showActivityInd();

	var headers = {};
	headers["X-Cardinal-Version"] = msProviderVersion;
	headers["X-Cardinal-ApplicationId"] = msApplicationId;
	if (msDebug) {
		headers["X-Cardinal-DeviceId"] = DebugVars.id;
	} else {
		headers["X-Cardinal-DeviceId"] = Ti.Platform.id;
	} 
	headers["X-Cardinal-Carrier"] = "";
	headers["X-Cardinal-ApplicationToken"] = msApplicationToken;
	headers["X-Cardinal-Cipher"] = msCipher;
	headers["X-Cardinal-SessionToken"] = msContext;
	headers["X-Cardinal-ClientToken"] = strClientToken;
	
	 	
	var requestObj = {};
	requestObj["ProcessorId"] = msProcessorId;
	requestObj["CustomerId"] = msCustomerId;
	requestObj["RequestId"] = randomString(12);
	requestObj["Provider"] = msProvider;
	requestObj["ProviderConfiguration"] = msProviderConfiguration;
	requestObj["Version"] = msRESTAPIVersion;
	requestObj["GiftCardKey"] = txtMoneyPak.value;
	requestObj["Context"] = msContext;
	
    sendJSONRequest(msRESTEndpoint + "/ReloadMgmt.svc/GetBalance", requestObj, "MoneyPakSuccessHandler", "MoneyPakErrorHandler", headers);
    
});

Titanium.App.addEventListener('MoneyPakSuccessHandler', function(e){
	
	if (e.GetReloadCardBalanceResult.Status != "0") {
		getAlert(e.GetReloadCardBalanceResult.ErrorDesc);
		
	}
	else {
		lblConfirmAmt.text = "$" + e.GetReloadCardBalanceResult.SmpsUserPayments[0].BalanceAmount;
		lblAmountAdded.text = "$" + e.GetReloadCardBalanceResult.SmpsUserPayments[0].BalanceAmount;
		lblConfirmAcct.text = '*'+ msCard.LastFour;
		
		redirect("addMoneyScreen", "initialize", {action:"validate"});
	}
	
	
});

Titanium.App.addEventListener('MoneyPakErrorHandler', function(e){
	getAlert(e.GetReloadCardBalanceResult.ErrorDesc);
});

Titanium.App.addEventListener('ApplyMoneyPak', function(e){
    var strClientToken = Titanium.App.Properties.getString("User_" + txtUserId.value);

	showActivityInd();

	var headers = {};
	headers["X-Cardinal-Version"] = msProviderVersion;
	headers["X-Cardinal-ApplicationId"] = msApplicationId;
	if (msDebug) {
		headers["X-Cardinal-DeviceId"] = DebugVars.id;
	} else {
		headers["X-Cardinal-DeviceId"] = Ti.Platform.id;
	} 
	headers["X-Cardinal-Carrier"] = "";
	headers["X-Cardinal-ApplicationToken"] = msApplicationToken;
	headers["X-Cardinal-Cipher"] = msCipher;
	headers["X-Cardinal-SessionToken"] = msContext;
	headers["X-Cardinal-ClientToken"] = strClientToken;
	
	 	
	var requestObj = {};
	requestObj["ProcessorId"] = msProcessorId;
	requestObj["CustomerId"] = msCustomerId;
	requestObj["RequestId"] = randomString(12);
	requestObj["Provider"] = msProvider;
	requestObj["ProviderConfiguration"] = msProviderConfiguration;
	requestObj["Version"] = msRESTAPIVersion;
	requestObj["GiftCardKey"] = txtMoneyPak.value;
	requestObj["ReloadAmount"] = "25";
	requestObj["Context"] = msContext;
	
    sendJSONRequest(msRESTEndpoint + "/ReloadMgmt.svc/ReloadCard", requestObj, "ApplyMoneyPakSuccessHandler", "ApplyMoneyPakErrorHandler", headers);
    
});

Titanium.App.addEventListener('ApplyMoneyPakSuccessHandler', function(e){
	
	if (e.ReloadCardResult.Status != "0") {
		getAlert(e.ReloadCardResult.ErrorDesc);
	}
	else {
		
		// Set msCard to NULL, this will force a reload of the card detail info
		msCard = null;
		
		history.pop();
		redirect("addMoneyScreen", "initialize", {action:"congrats"});
	}
	
	
});

Titanium.App.addEventListener('ApplyMoneyPakErrorHandler', function(e){
	getAlert(e.ReloadCardResult.ErrorDesc);
});

