/**
 * @author ryucha
 * business logic for balance/hub screen
 */

winAccountBalance.initialize = function(args){

	if (args.backButton == true && msCard != null) {
		return true;
	}
	else 
	{
		if (msCard == null) {
			winAccountBalance.GetCardDetails({
				AccountIdentifier: msCardId
			});
			
			// returning false to take control of this redirect...
			return false;
		} else {
			// We have already run the GetCardDetails, and now have it cached, reset the history so we can't go back from here
			history = [];
			
			var historyEntry = {};
			historyEntry.target = "accountBalanceScreen";
			historyEntry.handler = "initialize";
			historyEntry.args = {}
			
			history.push(historyEntry);
			
			return true;
		}
	}
}

winAccountBalance.addEventListener('android:back', function(e) {
	// Don't do anything, we don't want the user to be able to go past the hub screen
	return;
});
winAccountBalance.addEventListener('open', function() {
	isLoggedIn = true;
});

//transactions
btnViewTransactions.addEventListener('click', function(){
	redirect("transactionScreen", null, null);
});

//go to add money
btnAddMoney.addEventListener('click', function(){
	lblAccountBalanceAmt2.text = formatNegativeAmount(msCard.AvailableBalance);
	
	redirect("addMoneyScreen", null, null);
});

//go to find ATMs
btnFindLocation.addEventListener('click', function(){
	Titanium.App.fireEvent('findATMClick', {
    });
});

//go to find reload locations
btnFindReload.addEventListener('click', function(){
	Titanium.App.fireEvent('findReloadClick', {
    });
});

//go to waive monthly charge screen
btnWaiveFee.addEventListener('click', function(){
	Titanium.App.fireEvent('waiveFeeClick', {
    });
});
btnCallCustomerCare.addEventListener('click',function() {
	Titanium.App.fireEvent('callCustomerServiceClick', {
    });
});

Titanium.App.addEventListener('findATMClick', function(e){
	
	redirect("reloadATMScreen", "initialize", {screenType:"atm"});
});

Titanium.App.addEventListener('findReloadClick', function(e){
	
	redirect("reloadATMScreen", "initialize", {screenType:"retail"});
});

Titanium.App.addEventListener('waiveFeeClick', function(e){
	
	redirect("waiveChargeScreen", "initialize", {});
});
Titanium.App.addEventListener('callCustomerServiceClick', function(e) {
    callCustomerCare();
});

winAccountBalance.GetCardDetails = function(e){
    var strClientToken = Titanium.App.Properties.getString("User_" + txtUserId.value);
	
	showActivityInd();
	
	var headers = {};
	headers["X-Cardinal-Version"] = msProviderVersion;
	headers["X-Cardinal-ApplicationId"] = msApplicationId;
	if (msDebug) {
		headers["X-Cardinal-DeviceId"] = DebugVars.id;
	} else {
		headers["X-Cardinal-DeviceId"] = Ti.Platform.id;
	}
	headers["X-Cardinal-Carrier"] = "";
	headers["X-Cardinal-ApplicationToken"] = msApplicationToken;
	headers["X-Cardinal-Cipher"] = msCipher;
	headers["X-Cardinal-SessionToken"] = msContext;
	headers["X-Cardinal-ClientToken"] = strClientToken;
	
	 	
	var requestObj = {};
	requestObj["ProcessorId"] = msProcessorId;
	requestObj["CustomerId"] = msCustomerId;
	requestObj["RequestId"] = randomString(12);
	requestObj["MobileNumber"] = txtUserId.value;
	requestObj["Password"] = txtPassword.value;
	requestObj["Provider"] = msProvider;
	requestObj["ProviderConfiguration"] = msProviderConfiguration;
	requestObj["Version"] = msRESTAPIVersion;
	requestObj["PaymentKey"] = e.AccountIdentifier;
	requestObj["Context"] = msContext;
	
    sendJSONRequest(msRESTEndpoint + "/Service.svc/GetMobileUserPaymentAccount", requestObj, "CardDetailsSuccessHandler", "CardDetailsErrorHandler", headers);
    
}

Titanium.App.addEventListener('CardDetailsSuccessHandler', function(e){
	
	if (e.GetMobileUserPaymentAccountResult.Status != "0") {
		getAlert(e.GetMobileUserPaymentAccountResult.ErrorDesc);
		logout();
		return;
	}
	
	msCard = e.GetMobileUserPaymentAccountResult.Card;
	msCard.BillingCycleStartString = e.GetMobileUserPaymentAccountResult.BillingCycleStartString;
	msCard.BillingCycleEndString = e.GetMobileUserPaymentAccountResult.BillingCycleEndString;
	msCard.BillingCycleDaysRemaining = e.GetMobileUserPaymentAccountResult.BillingCycleDaysRemaining;
	msWaivers = e.GetMobileUserPaymentAccountResult.FeeWaivers;
	
	Titanium.App.Properties.setString("lastScreen", "accountBalanceScreen");
	lblAccountNo.text ='*' + msCard.LastFour;
	
	lblAccountBalanceBig.text = formatNegativeAmount(msCard.AvailableBalance);
	lblAccountBalanceAmt2.text = formatNegativeAmount(msCard.AvailableBalance);
	lblAccountBalanceAmt.text = formatNegativeAmount(msCard.AvailableBalance);
	
	for (var x = 0; x < e.GetMobileUserPaymentAccountResult.MiniStatementTransactionHistories[0].ReturnFields.length; x++) {
		if (e.GetMobileUserPaymentAccountResult.MiniStatementTransactionHistories[0].ReturnFields[x].Name == "BillCycleId") {
			msBillCycleId = e.GetMobileUserPaymentAccountResult.MiniStatementTransactionHistories[0].ReturnFields[x].Value;
		}
	}
	for (var w = 0; w < e.GetMobileUserPaymentAccountResult.Card.ReturnFields.length; w++) {
		if (e.GetMobileUserPaymentAccountResult.Card.ReturnFields[w].Name == "WebSkinId") {
			msWebSkinId = e.GetMobileUserPaymentAccountResult.Card.ReturnFields[w].Value;
		}
	}

	if(msWebSkinId == '12') {
		msPremierAccount = true;
		menuOffset = 47;
		
		btnViewTransactions.top += menuOffset;
		btnAddMoney.top += menuOffset;
		btnFindLocation.top += menuOffset;
		btnFindReload.top += menuOffset;
		btnWaiveFee.visible = false;
	}
	redirect("accountBalanceScreen", null, null);
	
});

Titanium.App.addEventListener('CardDetailsErrorHandler', function(e){
	getAlert(e.GetMobileUserPaymentAccountResult.ErrorDesc);
	logout();
	return;
});


