/**
 * @author mweidner
 */
winLoginScreen.initialize = function(args){
	if (msBoolUpdateRequired == null) {
		winLoginScreen.VersionCheck({});
		return;
	}
	
	if (args.action == "logout") {
		// "Showing login screen after logout."
	}
	
	// returning true to give control back to the redirect function
	//txtUserId.focus();
	return true;
}
winLoginScreen.addEventListener('android:back', function(e) {
	// This should not be able to go back
	return;
});
btnLogin.addEventListener('click', function(){
	if (txtUserId.value == null) {
		getAlert('User ID required.');
		return;
	}
	if (txtPassword.value == null) {
		getAlert('Password required.');
		return;
	}
	if (txtUserId.value.length < 1) {
		getAlert('User ID required.');
		return;
	}
	if (txtPassword.value.length < 1) {
		getAlert('Password required.');
		return;
	}
	txtUserId.clearOnEdit = false;
	txtUserId.value = txtUserId.value.toLowerCase();
    Titanium.App.fireEvent('Login', {
        UserId: txtUserId.value,
		Password: txtPassword.value
    });
	txtPassword.blur();
	txtUserId.blur();
	// Save the username if they have RememberMe selected:
	if (swchRemember.value == true) {
		Titanium.App.Properties.setString("RememberMe", txtUserId.value);
	}

});

lblTermsLink.addEventListener('click', function() {
	Titanium.App.fireEvent('TermsAndConditionClick', {});
});
txtPassword.addEventListener('change',function() {
	txtPassword.passwordMask = true;	
});

if (Titanium.Platform.name == 'iPhone OS') {
	viewLogin.addEventListener('singletap', function(e){
		txtUserId.blur();
		txtPassword.blur();
	});

	viewHeaderGD.addEventListener('singletap', function(){
		txtUserId.blur();
		txtPassword.blur();
		txtAnswer.blur();
	});
} else if (Titanium.Platform.osname == 'android') {
	txtUserId.addEventListener('blur', function(){		
		Ti.UI.Android.hideSoftKeyboard();
	});
	txtPassword.addEventListener('blur', function(){		
		Ti.UI.Android.hideSoftKeyboard();
	});
	txtUserId.addEventListener('click', function() {
		txtUserId.focus();
	});
	txtPassword.addEventListener('click', function() {
		txtPassword.focus();
	});
	
} 
Titanium.App.addEventListener('Login', function(e){
    var strClientToken = Titanium.App.Properties.getString("User_" + txtUserId.value.toLowerCase());

	showActivityInd();

	var headers = {};
	headers["X-Cardinal-Version"] = msProviderVersion;
	headers["X-Cardinal-ApplicationId"] = msApplicationId;
	if (msDebug) {
		headers["X-Cardinal-DeviceId"] = DebugVars.id;
	} else {
		headers["X-Cardinal-DeviceId"] = Ti.Platform.id;
	}
	headers["X-Cardinal-Carrier"] = "";
	headers["X-Cardinal-ApplicationToken"] = msApplicationToken;
	headers["X-Cardinal-Cipher"] = msCipher;
	headers["X-Cardinal-SessionToken"] = msContext;
	headers["X-Cardinal-ClientToken"] = strClientToken;
	
	 	
	var requestObj = {};
	requestObj["ProcessorId"] = msProcessorId;
	requestObj["CustomerId"] = msCustomerId;
	requestObj["RequestId"] = randomString(12);
	requestObj["MobileNumber"] = e.UserId;
	requestObj["Password"] = e.Password;
	requestObj["Provider"] = msProvider;
	requestObj["ProviderConfiguration"] = msProviderConfiguration;
	requestObj["Version"] = msRESTAPIVersion;
	if (e.SecurityQuestionId != null) {
		requestObj["SecurityQuestionId"] = e.SecurityQuestionId;
		requestObj["SecurityQuestionValue"] = e.SecurityQuestionValue;
	}
	
    sendJSONRequest(msRESTEndpoint + "/Service.svc/AuthenticateMobileUserClientWallet", requestObj, "LoginSuccessHandler", "LoginErrorHandler", headers);
    
});

Titanium.App.addEventListener('LoginSuccessHandler', function(e){
	txtAnswer.value = "";
	if (e.AuthenticateMobileUserClientWalletResult.Status != "0") {
		if (e.AuthenticateMobileUserClientWalletResult.ErrorNo == "10206") {
			getAlert(e.AuthenticateMobileUserClientWalletResult.ErrorDesc);
			
			var nextQuestionNumber = lblSecurityQuestionOrigId.text + 1;
			if (nextQuestionNumber > 2) {
				nextQuestionNumber = 0;
			}
			lblSecurityQuestionOrigId.text = nextQuestionNumber;
			
			lblSecurityQuestionId.text = msSecurityQuestions[nextQuestionNumber].Key;
			lblSecurityQuestion.text = msSecurityQuestions[nextQuestionNumber].Value;
			
			redirect("securityScreen", null, null);
			
			return;
		}
		else 
		{
			getAlert(e.AuthenticateMobileUserClientWalletResult.ErrorDesc);
			return;
		}
	}
	
	if (e.AuthenticateMobileUserClientWalletResult.ClientToken != null) {
		
		// Set the ClientToken to a saved property
		Titanium.App.Properties.setString("User_" + txtUserId.value.toLowerCase(), e.AuthenticateMobileUserClientWalletResult.ClientToken);
		
		isLoggedIn = true;
		txtPassword.value = "";
		msCardId = e.AuthenticateMobileUserClientWalletResult.Cards[0].AccountIdentifier;
		redirect("accountBalanceScreen", null, null);
		

	} 
	else 
	{
		
		msContext = e.AuthenticateMobileUserClientWalletResult.Context;
		msCipher = e.AuthenticateMobileUserClientWalletResult.Cipher;	
		
		if (e.AuthenticateMobileUserClientWalletResult.SecurityQuestionList != null && e.AuthenticateMobileUserClientWalletResult.SecurityQuestionList.length >= 1) {
			//winLoginScreen.close();
			var questionNumber = Math.floor(Math.random() * e.AuthenticateMobileUserClientWalletResult.SecurityQuestionList.length);	
			msSecurityQuestions = e.AuthenticateMobileUserClientWalletResult.SecurityQuestionList;
			lblSecurityQuestionOrigId.text = questionNumber;
			lblSecurityQuestionId.text = e.AuthenticateMobileUserClientWalletResult.SecurityQuestionList[questionNumber].Key;
			lblSecurityQuestion.text = e.AuthenticateMobileUserClientWalletResult.SecurityQuestionList[questionNumber].Value;
			
			redirect("securityScreen", null, null);
		}
		else 
		{
			
			isLoggedIn = true;
			txtPassword.value = "";
			msCardId = e.AuthenticateMobileUserClientWalletResult.Cards[0].AccountIdentifier;
			redirect("accountBalanceScreen", null, null);
		}
		
	}
	
	
});

Titanium.App.addEventListener('LoginErrorHandler', function(e){
	getAlert(e.AuthenticateMobileUserClientWalletResult.ErrorDesc);	
});

winLoginScreen.VersionCheck = function(e){
    var headers = {};
	headers["X-Cardinal-Version"] = msProviderVersion;
	headers["X-Cardinal-ApplicationId"] = msApplicationId;
	if (msDebug) {
		headers["X-Cardinal-DeviceId"] = DebugVars.id;
	} else {
		headers["X-Cardinal-DeviceId"] = Ti.Platform.id;
	} 
	headers["X-Cardinal-Carrier"] = "";
	headers["X-Cardinal-ApplicationToken"] = msApplicationToken;
	
	 	
	var requestObj = {};
	requestObj["ProcessorId"] = msProcessorId;
	requestObj["CustomerId"] = msCustomerId;
	requestObj["RequestId"] = randomString(12);
	requestObj["ApplicationId"] = msApplicationId;
	requestObj["ApplicationVersion"] = msApplicationVersion;
	requestObj["DeviceFamily"] = msDeviceFamily;
	requestObj["Provider"] = msProvider;
	requestObj["ProviderConfiguration"] = msProviderConfiguration;
	requestObj["Version"] = msRESTAPIVersion;

	
    sendJSONRequest(msRESTEndpoint + "/Service.svc/VersionCheck", requestObj, "VersionCheckSuccessHandler", "VersionCheckErrorHandler", headers);
    
}

Titanium.App.addEventListener('VersionCheckSuccessHandler', function(e){
	
	if (e.VersionCheckResult.Status != "0") {
		redirect("errorScreen", "LoginFailed", {msg:networkPersistantError});
	}
	else 
	{
		// VersionCheck success
		if (e.VersionCheckResult.ApplicationDeviceVersion.VersionUpdateFlag == "UpdateRequired") {
			msBoolUpdateRequired = true;
			redirect("errorScreen", "LoginFailed", {msg:e.VersionCheckResult.ApplicationDeviceVersion.UpdateAvailableVersionMessage});
		} else if (e.VersionCheckResult.ApplicationDeviceVersion.VersionUpdateFlag == "UpdateAvailable") {
			msBoolUpdateRequired = false;
			getAlert(e.VersionCheckResult.ApplicationDeviceVersion.UpdateAvailableVersionMessage);
			redirect("loginScreen", null, null);
		} else {
			msBoolUpdateRequired = true;
			redirect("loginScreen", null, null);
		}
	}
	
	
});

Titanium.App.addEventListener('VersionCheckErrorHandler', function(e){
	//Ti.API.info('Versioncheck utterly failed...');
	// We do not want to kill the app if we get an error back, allow on to the login screen
	redirect("loginScreen", null, null);
	return;
});

swchRemember.addEventListener('change',function(e)
{
	if (e.value == false) {
		Titanium.App.Properties.setString("RememberMe", "");
	}
});

Titanium.App.addEventListener('TermsAndConditionClick', function(e) {
	btnAgree.visible = false;
	btnCancelTC.visible = false;
	lblInstructions.visible = false;
	btnBack.visible = true;
	
	redirect("termsScreen", null, null);
});

