/**
 * @author ryucha
 */
var screenType = '';

winReloadLocation.initialize = function(args) {
	
	if (args.action == null) {
		// Set what screenType we want:
		screenType = args.screenType;
		
		// Setup the items on the screen:
		if(screenType == 'atm') {
			lblATMLocationTitle.text = freeATMsText;
			lblReloadLocationNear.visible = false;
			lblATMLocationNear.visible = true;
		} else if (screenType == 'retail') {
			lblATMLocationTitle.text = reloadLocationText;
			lblReloadLocationNear.visible = true;
			lblATMLocationNear.visible = false;
		}
		
		if (args.backButton == true) {
			overrideInternalRedirect(true);
		}
		
		// Remove the other views:
		winReloadLocation.remove(mapLocations);
		winReloadLocation.remove(btnGreenGetDirections);
		winReloadLocation.remove(btnViewMapLocations);
		winReloadLocation.remove(btnViewResults);
		winReloadLocation.remove(viewATMPlainHeader);
		winReloadLocation.remove(viewLocationList);
		
		// Setup this view
		winReloadLocation.add(viewFindReloadLocation);
		winReloadLocation.add(viewATMPlainHeader);
		if (Ti.Platform.name == 'iPhone OS') {
			viewPicker.hide();
			viewFindReloadLocation.scrollTo(0, 0);
		}
		return true;
	} else if (args.action == "location_list") {
		
		// Override the normal redirect so that it adds the history object, but doesn't actually close then reopen this window:
		overrideInternalRedirect(true);

		// Hide the other views:
		winReloadLocation.remove(viewFindReloadLocation);
		if (Ti.Platform.name == 'iPhone OS') {
			winReloadLocation.remove(viewPicker);
		}
		winReloadLocation.remove(mapLocations);
		winReloadLocation.remove(btnGreenGetDirections);
		winReloadLocation.remove(btnViewResults);
		winReloadLocation.remove(viewATMPlainHeader);
		
		// Setup this view
		viewLocationList.data = tbRowLocationRows;
		winReloadLocation.add(viewLocationList);
		winReloadLocation.add(btnViewMapLocations);
		winReloadLocation.add(viewATMPlainHeader);
		
		return true;
	} else if (args.action == "map_single_location") {
		overrideInternalRedirect(true);
		
		// Hide the other views
		winReloadLocation.remove(viewLocationList);
		winReloadLocation.remove(viewFindReloadLocation);
		winReloadLocation.remove(mapLocations);
		winReloadLocation.remove(viewATMPlainHeader);
		winReloadLocation.remove(btnViewMapLocations);
		winReloadLocation.remove(btnViewResults);
		
		// Setup this view
		winReloadLocation.add(mapLocations);
		winReloadLocation.add(btnGreenGetDirections);
		winReloadLocation.add(viewATMPlainHeader);
		
		return true;
	} else if (args.action == "map_all_locations") {
		// Override the normal redirect so that it adds the history object, but doesn't actually close then reopen this window:
		overrideInternalRedirect(true);

		// Reload the map data into this view
		winReloadLocation.LoadMapData(msLocationsRawResult);
	
		// Hide the other views
		winReloadLocation.remove(viewLocationList);
		winReloadLocation.remove(viewFindReloadLocation);
		winReloadLocation.remove(viewATMPlainHeader);
		winReloadLocation.remove(btnViewMapLocations);
		
		// Setup this view
		winReloadLocation.add(mapLocations);
		winReloadLocation.add(btnViewResults);
		winReloadLocation.add(viewATMPlainHeader);
		
		return true;	
	} else {
		// "Got an action we were not expecting!"
	}
}

winReloadLocation.addEventListener('android:back', function(e) {
	goBack();
});
if (Titanium.Platform.name == 'iPhone OS') {
	lblBlankState.addEventListener('focus', function() {
		
	});
	lblBlankState.addEventListener('click', function() {
		viewPicker.show();
		txtState.blur();
	});
	btnDropDown.addEventListener('click', function() {
		viewPicker.show();
		txtState.blur();
	});
	cancelPicker.addEventListener('click', function() {
		viewFindReloadLocation.scrollTo(0,0);
		viewPicker.hide();
	});
	donePicker.addEventListener('click', function() {
		txtState.value = pkrState.getSelectedRow(0).custom_item;
		viewFindReloadLocation.scrollTo(0,0);
		viewPicker.hide();
	});
	btnFindCity.addEventListener('click', function() {
		txtCity.blur();
	});
	txtState.addEventListener('blur', function() {
		viewPicker.hide();
	});
	txtCity.addEventListener('blur', function() {
		viewPicker.hide();
	});

	viewInsideFindReloadLocation.addEventListener('singletap', function(){
		txtCity.blur();
		txtLocationInfo.blur();
		txtState.blur();
	});
} else if (Titanium.Platform.name == 'android') {
	var androidStateValue = '';
	pkrState.addEventListener('change', function(e) {
		//Ti.API.info('Picker change event...');
		//Ti.API.info('Picker row:' + e.row);
		androidStateValue = e.row.title;
		//Ti.API.info('Picker row value:' + e.row.title);
	});
}

//find local reload or ATM locations
btnFindAddress.addEventListener('click', function(){

	if (txtLocationInfo.value == null) {
		getAlert('Zip Code required.');
		return;
	}

	if (txtLocationInfo.value.length >= 5 && IsNumeric(txtLocationInfo.value) == true) {
		Titanium.App.fireEvent('GetLocations', {
			Zip: txtLocationInfo.value,
			City: '',
			State: '',
			Lat: '',
			Long: ''
		});
		msUserZip = txtLocationInfo.value;
		txtLocationInfo.blur();
	} else {
		getAlert('Zip Code required.');
	}
});
if (Ti.Platform.name == 'iPhone OS') {
	btnFindCity.addEventListener('click', function(){
	
	if (txtCity.value != '' && txtState.value != '') {
		Titanium.App.fireEvent('GetLocations', {
			City: txtCity.value,
			State: txtState.value,
			Zip: '',
			Lat: '',
			Long: ''
		});
		
		txtCity.blur();
		txtState.blur();
	} else {
		getAlert('City/State required.');
	}
	
	
});

viewFindReloadLocation.addEventListener('singletap', function(){
		txtLocationInfo.blur();
	});
} else if (Ti.Platform.name == 'android') {
	btnFindCity.addEventListener('click', function(){
	
	
	if(txtCity.value == null) {
		getAlert('City/State required.');
		return;
	}
	
	if(androidStateValue == null) {
		getAlert('City/State required.');
		return;
	}
	
	//Ti.API.info('Selected State: ' + androidStateValue);
	
	if (txtCity.value != '' && androidStateValue != '') {
		Titanium.App.fireEvent('GetLocations', {
			City: txtCity.value,
			State: androidStateValue,
			Zip: '',
			Lat: '',
			Long: ''
		});
		
	} else {
		getAlert('City/State required.');
	};
});
	
};


//find local reload or ATM locations
btnUseCurrentLocation.addEventListener('click', function(){
	if (Titanium.Platform.name == 'iPhone OS') {
		Titanium.Geolocation.purpose = "Find nearby " + screenType + " locations";
	}
	Titanium.Geolocation.getCurrentPosition(function(e) {
       if (e.error) {
         ///  Ti.API.log('error: ' + JSON.stringify(e) );
           return;
       }

       msUserRegion = {
               latitude:e.coords.latitude,
               longitude:e.coords.longitude,
               animate:true,
               latitudeDelta:0.075,
               longitudeDelta:0.075
       };
	   
	   Titanium.App.fireEvent('GetLocations', {
		Lat: msUserRegion.latitude,
		Long: msUserRegion.longitude,
		Zip: '',
		City: '',
		State: ''
      });
	});
	
});

btnViewMapLocations.addEventListener('click', function(){
	redirect("reloadATMScreen", "initialize", {action:"map_all_locations"})
	
});

btnViewResults.addEventListener('click', function(){
	goBack();
});

viewLocationList.addEventListener('click', function(){
	redirect("reloadATMScreen", "initialize", {action:"map_single_location"})
});

btnGreenGetDirections.addEventListener('click', function(e){
	var lat = "";
	var lon = "";
	if (msUserRegion != null) {
		lat = msUserRegion.latitude;
		lon = msUserRegion.longitude;
	}
	
//	if (txtLocationInfo.value == '' || txtLocationInfo.value == 'Enter address or zip') {
		Titanium.App.fireEvent('getDirectionsClick', {
			SourceLat: lat,
			SourceLong: lon,
			DestStreet: msLocations[locationIndex].Street,
			DestCity: msLocations[locationIndex].City,
			DestState: msLocations[locationIndex].State,
			DestZip: msLocations[locationIndex].Zip
		});
	/*} else {
		Titanium.App.fireEvent('getDirectionsClick', {
			SourceZip: txtLocationInfo.value,
			DestLat: msLocations[locationIndex].Latitude,
			DestLong: msLocations[locationIndex].Longitude
		});
	}*/
	
	
});

btnHomeButtonATM.addEventListener('click', function(){
	if(Ti.Platform.name == 'iPhone OS') {
		txtCity.blur();
		txtLocationInfo.blur();
		txtState.blur();	
	}
	
	goHome();
});

btnBackButtonATM.addEventListener('click', function(){
	if(Ti.Platform.name == 'iPhone OS') {
		txtCity.blur();
		txtLocationInfo.blur();
		txtState.blur();	
	}
	goBack();
});
btnHomeButtonReload.addEventListener('click', function() {
	if(Ti.Platform.name == 'iPhone OS') {
		txtCity.blur();
		txtLocationInfo.blur();
		txtState.blur();	
	}
	goHome();
});

btnBackButtonReload.addEventListener('click', function() {
	if(Ti.Platform.name == 'iPhone OS') {
		txtCity.blur();
		txtLocationInfo.blur();
		txtState.blur();	
	}
	goBack();
});
mapLocations.addEventListener('error', function(){
//	Titanium.App.fireEvent('MapSpecificLocation', {
//	});
});

Titanium.App.addEventListener('getDirectionsClick', function(e){
	
//http://maps.google.com/maps
//?saddr=Mentor,+OH
//&daddr=9189+Lorrich+Drive,+Mentor,+OH
	var sourceAddr = '';
	if (e.SourceLat != '' && e.SourceLong != '') {
		sourceAddr = e.SourceLat + ',' + e.SourceLong;
	} else {
		sourceAddr = ''; //txtLocationInfo.value;
	}
	
	getDirections(sourceAddr, e.DestStreet, e.DestCity, e.DestState, e.DestZip); 
});


var locationIndex;

Titanium.App.addEventListener('GetLocations', function(e){
    var strClientToken = Titanium.App.Properties.getString("User_" + txtUserId.value);
	//Ti.API.info('JSON text' + JSON.stringify(e));
	showActivityInd();

	var headers = {};
	headers["X-Cardinal-Version"] = msProviderVersion;
	headers["X-Cardinal-ApplicationId"] = msApplicationId;
	if (msDebug) {
		headers["X-Cardinal-DeviceId"] = DebugVars.id;
	} else {
		headers["X-Cardinal-DeviceId"] = Ti.Platform.id;
	}
	headers["X-Cardinal-Carrier"] = "";
	headers["X-Cardinal-ApplicationToken"] = msApplicationToken;
	headers["X-Cardinal-Cipher"] = msCipher;
	headers["X-Cardinal-SessionToken"] = msContext;
	headers["X-Cardinal-ClientToken"] = strClientToken;
	
	 	
	var requestObj = {};
	requestObj["ProcessorId"] = msProcessorId;
	requestObj["CustomerId"] = msCustomerId;
	requestObj["RequestId"] = randomString(12);
	requestObj["MobileNumber"] = txtUserId.value;
	requestObj["Password"] = txtPassword.value;
	requestObj["Provider"] = msProvider;
	requestObj["ProviderConfiguration"] = msProviderConfiguration;
	requestObj["Version"] = msRESTAPIVersion;
	requestObj["Context"] = msContext;
	requestObj["Radius"] = msStoreSearchRadius;
	requestObj["Zip"] = e.Zip;
	requestObj["City"] = e.City;
	requestObj["State"] = e.State;
	requestObj["Latitude"] = e.Lat;
	requestObj["Longitude"] = e.Long;
	requestObj["LocationType"] = screenType;
	
    sendJSONRequest(msRESTEndpoint + "/ReloadMgmt.svc/StoreLocator", requestObj, "LocationsSuccessHandler", "LocationsErrorHandler", headers);
    
});

Titanium.App.addEventListener('LocationsSuccessHandler', function(e){
	msLocationsRawResult = e;
	
	if (e.StoreLocatorResult.MerchantLocations == null || e.StoreLocatorResult.MerchantLocations.length == 0) {
		getAlert('No locations found');
		redirect("reloadATMScreen", null,null);
		return;
	}
	
	winReloadLocation.LoadMapData(e);
	redirect("reloadATMScreen", "initialize", {action: 'location_list'});
});

winReloadLocation.LoadMapData = function(e) {
	
	if (e.StoreLocatorResult.Status != "0") {
		return;
	}
	tbRowLocationRows = [];
	
	//winReloadLocation.remove(mapLocations);
	var annotationList = [];
	mapLocations.removeAllAnnotations();
	
	for (var i=0; i<e.StoreLocatorResult.MerchantLocations.length; i++) {
		var Name = e.StoreLocatorResult.MerchantLocations[i].Name;
		var Lat = e.StoreLocatorResult.MerchantLocations[i].Latitude;
		var Long = e.StoreLocatorResult.MerchantLocations[i].Longitude;
		var Street = e.StoreLocatorResult.MerchantLocations[i].Street;
		var City = e.StoreLocatorResult.MerchantLocations[i].City;
		var State = e.StoreLocatorResult.MerchantLocations[i].State;
		var Zip = e.StoreLocatorResult.MerchantLocations[i].ZipCode;
		var Phone = e.StoreLocatorResult.MerchantLocations[i].Phone;
		
		msLocations = e.StoreLocatorResult.MerchantLocations;
		
		locLabelList[i] = Titanium.UI.createLabel({
			height:20,
			text:Name,
			color:'#000',
			font:{fontSize:10, fontFamily:fontName, fontWeight:'bold'},
			left: 10,
			top:0
		});
		
		addressLabelList[i] = Titanium.UI.createLabel({
			height:20,
			text:Street+","+City+','+State+","+Zip,
			color:'#000',
			font:{fontSize:10, fontFamily:fontName},
			left: 10,
			width:250,
			top:20
		});
		
		distLabelList[i] = Titanium.UI.createLabel({
			height:20,
			text:'',
			color:'#000',
			font:{fontSize:10, fontFamily:fontName},
			left:260
		});
		
		
		locViewList[i] = Titanium.UI.createView({});
		locViewList[i].add(locLabelList[i]);
		locViewList[i].add(addressLabelList[i]);
		locViewList[i].add(distLabelList[i]);
		
		tbRowLocationRows[i] = Titanium.UI.createTableViewRow({
				hasChild:true
			});	
			
		tbRowLocationRows[i].add(locViewList[i]);	

		annotationList[i] = Titanium.Map.createAnnotation({
			latitude: Lat,
			longitude: Long,
			title: Name,
			subtitle: Street + ", "+ City+ ", "+ State +", "+ Zip,
			animate:true,
			pincolor:Titanium.Map.ANNOTATION_RED,
			myid: i+1
		});
		
		mapLocations.addAnnotation(annotationList[i]);
	
		tbRowLocationRows[i].addEventListener('click', function(e){
			
			locationIndex = e.index;
			Titanium.App.fireEvent('MapSpecificLocation', {
				SpecificLocationName :  msLocations[e.index].Name,
				SpecificLocationStreet : msLocations[e.index].Street,
				SpecificLocationCity: msLocations[e.index].City,
				SpecificLocationState: msLocations[e.index].State,
				SpecificLocationZip: msLocations[e.index].ZipCode,
				SpecificLocationPhone : msLocations[e.index].Phone,
				SpecificLocationLat : msLocations[e.index].Latitude,
				SpecificLocationLong : msLocations[e.index].Longitude,
			});		
		});
	}
	
	// Don't try to set the locations region if we didn't get any results back
	if (e.StoreLocatorResult.MerchantLocations.length >= 1) {
		//Ti.API.info('Resetting region to ' + msLocations[0].City + ', ' + msLocations[0].State);
		mapLocations.hide();
		if (Titanium.Platform.name == 'android') {
			var region1 = {
				latitude: msLocations[0].Latitude,
				longitude: msLocations[0].Longitude,
				latitudeDelta: 0.05,
				longitudeDelta: 0.05
			}
			mapLocations.setLocation(region1);

		} else if (Titanium.Platform.name == 'iPhone OS') {
			mapLocations.region = {
				latitude: msLocations[0].Latitude,
				longitude: msLocations[0].Longitude,
				latitudeDelta: 0.05,
				longitudeDelta: 0.05
			};
		}
		
		
		mapLocations.show();
	}
}

Titanium.App.addEventListener('LocationsErrorHandler', function(e){
	//'StoreLocator Threw exception'
});

Titanium.App.addEventListener('MapSpecificLocation', function(e){
	mapLocations.removeAllAnnotations();

	var annotationLocation = Titanium.Map.createAnnotation({
		latitude: e.SpecificLocationLat,
		longitude: e.SpecificLocationLong,
		title: e.SpecificLocationName,
		subtitle: e.SpecificLocationStreet + ", "+ e.SpecificLocationCity+ ", "+ e.SpecificLocationState +", "+e.SpecificLocationZip,
		animate:true,
		pincolor:Titanium.Map.ANNOTATION_RED,
		myid: e.index+100, // CUSTOM ATTRIBUTE THAT IS PASSED INTO EVENT OBJECTS
	});

	mapLocations.hide();
	var region1 = {
		latitude:e.SpecificLocationLat, 
		longitude:e.SpecificLocationLong, 
		latitudeDelta: 0.075,
		longitudeDelta: 0.075
	}
	mapLocations.setLocation(region1);
	mapLocations.show();
	/*
	mapLocations.region= {
		latitude:e.SpecificLocationLat, 
		longitude:e.SpecificLocationLong, 
		latitudeDelta:0.075, 
		longitudeDelta:0.075
	};
	*/
	mapLocations.addAnnotation(annotationLocation);
	winReloadLocation.add(mapLocations);
	mapLocations.show();	
		
});
