/**
 * @author ryucha
 */

winTransactionScreen.initialize = function(args){
	
	
	if (args.action == null) {
		try {
			
			if (msTransactions == null) {
				viewSpecificTransaction.visible = false;
				winTransactionScreen.GetTransactions({});
				// returning false to take control of this redirect...
				return false;
			} else {
				if (args.backButton == true) {
					overrideInternalRedirect(true);
				}
				
				viewSpecificTransaction.visible = false;
				tableview.data = txnData;
				tableview.show();
				return true;
			}
			
		} catch (e){
			
		}
	} else if (args.backButton == true) {
		tableview.data = txnData;
		tableview.show();
		viewSpecificTransaction.visible = false;
		return false;
	} else if (args.action == "detail") {
		overrideInternalRedirect(true);
		
		tableview.hide();
		viewSpecificTransaction.visible = true;	
		return true;
	} else if (args.action == "display") {
		viewSpecificTransaction.visible = false;
		tableview.data = txnData;
		tableview.show();
		return true;
	} else {
		return true;
	}
	
}
winTransactionScreen.addEventListener('android:back', function(e) {
	goBack();
});

btnBackButtonT.addEventListener('click', function() {
	goBack();
});

btnHomeButtonT.addEventListener('click', function() {
	goHome();
});

winTransactionScreen.GetTransactions = function(e) {
	var strClientToken = Titanium.App.Properties.getString("User_" + txtUserId.value);

	showActivityInd();

	var headers = {};
	headers["X-Cardinal-Version"] = msProviderVersion;
	headers["X-Cardinal-ApplicationId"] = msApplicationId;
	if (msDebug) {
		headers["X-Cardinal-DeviceId"] = DebugVars.id;
	} else {
		headers["X-Cardinal-DeviceId"] = Ti.Platform.id;
	} 
	headers["X-Cardinal-Carrier"] = "";
	headers["X-Cardinal-ApplicationToken"] = msApplicationToken;
	headers["X-Cardinal-Cipher"] = msCipher;
	headers["X-Cardinal-SessionToken"] = msContext;
	headers["X-Cardinal-ClientToken"] = strClientToken;
	if (msBillCycleId == null || msBillCycleId == "") {
		msBillCycleId = "0";
	}
	headers["X-Cardinal-BillCycleId"] = msBillCycleId;
	 	
	var requestObj = {};
	requestObj["ProcessorId"] = msProcessorId;
	requestObj["CustomerId"] = msCustomerId;
	requestObj["MobileNumber"] = txtUserId.value;
	requestObj["RequestId"] = randomString(12);
	requestObj["Provider"] = msProvider;
	requestObj["ProviderConfiguration"] = msProviderConfiguration;
	requestObj["Version"] = msRESTAPIVersion;
	requestObj["Context"] = msContext;
	requestObj["PaymentKey"] = msCard.AccountNumber;
	
	sendJSONRequest(msRESTEndpoint + "/Service.Svc/GetMobileTransactions", requestObj, "GetTransactionsSuccessHandler", "GetTransactionsErrorHandler", headers);
}

Titanium.App.addEventListener('GetTransactionsSuccessHandler', function(e) {
	if (e.GetMobileTransactionsResult.Status != "0") {
		
	} else {
		msTransactions = e.GetMobileTransactionsResult.MiniStatementTransactionHistories;
		
		// Loop through transactions:
		for (var i=0; i<msTransactions.length; i++) {
			var transactionDate = "";
			var merchant = "";
			var amount = msTransactions[i].Amount;
			var description = msTransactions[i].Description;
			var boolIsCredit;
			var transactionType = "";
			var merchantCategory;
			var transactionTime;
			var transactionType;
			
			for (var i2=0; i2<msTransactions[i].ReturnFields.length; i2++) {
				if (msTransactions[i].ReturnFields[i2].Name == "PostDate") {
					transactionDate = msTransactions[i].ReturnFields[i2].Value;
					transactionDate = formatDate(transactionDate);
				}
				if (msTransactions[i].ReturnFields[i2].Name == "Merchant") {
					merchant = msTransactions[i].ReturnFields[i2].Value;
				}
				if (msTransactions[i].ReturnFields[i2].Name == "Type") {
					transactionType = msTransactions[i].ReturnFields[i2].Value;
				}
				if (msTransactions[i].ReturnFields[i2].Name == "IsCredit") {
					boolIsCredit = msTransactions[i].ReturnFields[i2].Value;
				}
				if (msTransactions[i].ReturnFields[i2].Name == "MerchantCategory") {
					merchantCategory = msTransactions[i].ReturnFields[i2].Value;
				}	
				if (msTransactions[i].ReturnFields[i2].Name == "TransactionTime") {
					transactionTime = msTransactions[i].ReturnFields[i2].Value;
				}	
				if (msTransactions[i].ReturnFields[i2].Name == "TransactionType") {
					transactionType = msTransactions[i].ReturnFields[i2].Value;
				}			
			}
			
			if (transactionDate == "") {
				transactionDate = formatDate(msTransactions[i].TransactionTime);
			}
			
			var transactionTypeText = "";
			if (transactionType != "Posted") {
				transactionTypeText = ' (' + transactionType + ')';
			}
			  
			var dateLabel = 
			  		Titanium.UI.createLabel({
					height:20,
					left:10,
					top:5,
					width:200,
					text: transactionDate + transactionTypeText,
					color:'#000',
					font:{fontSize:14, fontFamily:fontName}
				});
				
			var transLabel =
				Titanium.UI.createLabel({
					height:20,
					left:10,
					top:20,
					width:220,
					text: merchant,
					color:'#000',
					font:{fontSize:14, fontFamily:fontName},
					visible:true
				});
				
			if(transactionType == 'Declined') {
				var amtLabel = Titanium.UI.createLabel({
					height:15,
					left:200,
					top:10,
					width:80,
					text:'$' + amount,
					color:'#c0c0c0',
					font:{fontSize:14, fontFamily:fontName},
					textAlign:'right'
				});
			} else if(boolIsCredit == 'true') {
				var amtLabel = Titanium.UI.createLabel({
					height:15,
					left:200,
					top:10,
					width:80,
					text:'+ $' + amount,
					color:'#154925',
					font:{fontSize:14, fontFamily:fontName},
					textAlign:'right'
				});
			} else {
				var amtLabel = Titanium.UI.createLabel({
					height:15,
					top:10,
					left:200,
					width:80,
					text:'$' + amount,
					color:'#000',
					font:{fontSize:14, fontFamily:fontName},
					textAlign:'right'
				});
			}
			
				
			
			txnData[i] = Ti.UI.createTableViewRow({hasChild:true});
			txnData[i].className = "datarow";
			
			txnData[i].add(dateLabel);
			txnData[i].add(transLabel);
			txnData[i].add(amtLabel);
			
			
			txnData[i].addEventListener('click', function(e){
				var detailDate;
				var detailMerchant;
				var detailStatus;
				var detailTransactionType;
				var detailTransactionDate;
				var detailCategory;
				var detailType;
				
				for (var i3 = 0; i3 < msTransactions[e.index].ReturnFields.length; i3++) {
					if (msTransactions[e.index].ReturnFields[i3].Name == "PostDate") {
						detailDate = msTransactions[e.index].ReturnFields[i3].Value;
						detailDate = formatDate(detailDate);
					}
					if (msTransactions[e.index].ReturnFields[i3].Name == "Merchant") {
						detailMerchant = msTransactions[e.index].ReturnFields[i3].Value;
					}
					if (msTransactions[e.index].ReturnFields[i3].Name == "MerchantCategory") {
						detailCategory = msTransactions[e.index].ReturnFields[i3].Value;
					}
					detailTransactionType = msTransactions[e.index].TransactionType;

					detailTransactionDate = msTransactions[e.index].TransactionTime;
					detailTransactionDate = formatDate(detailTransactionDate);
					
					if (msTransactions[e.index].ReturnFields[i3].Name == "Type") {
						detailType = msTransactions[e.index].ReturnFields[i3].Value;
					}
					
				}
				locationIndex = e.index;		
						
				Titanium.App.fireEvent('tableRowClick', {});
				lblTransDate.text = detailDate;
				lblTransactionItem1.text = detailMerchant;
				if (detailTransactionType == 'Credit') {
					
					lblTransactionItem4.text = '+ $' + msTransactions[e.index].Amount;
					lblTransactionItem4.color = '#154925';
					lblTransactionItem3.text = 'Type: ' + detailTransactionType;

				} else {
					lblTransactionItem4.color = '#000';
					lblTransactionItem4.text = '$' + msTransactions[e.index].Amount;
					lblTransactionItem3.text = 'Type: ' + detailTransactionType;

				}

				lblTransactionItem2.text = 'Status: ' + detailType;
				
				lblTransactionItem5.text = 'Category: ' + detailCategory;
				lblTransactionItem6.text = 'Transaction Date: ' + detailTransactionDate;
			});
			
		} // end loop
		tableview.data = txnData;
		overrideInternalRedirect(true);
		redirect("transactionScreen", "initialize", {action:"display"});
	}
});

Titanium.App.addEventListener('tableRowClick', function(e){
	redirect("transactionScreen", "initialize", {action:"detail"});
});
