/**
 * @author ryucha
 * UI screen Terms and Conditions
 */

var winTermsAndConditions = Titanium.UI.createView({});
windowsMap.termsScreen = winTermsAndConditions;
winHub.add(winTermsAndConditions);


var viewTerms = Titanium.UI.createView({
	height:'auto',
	width:platformWidth * 0.9,
	backgroundColor:"#fff",
	bottom:0,
	alignText:'center'	
});

var viewFooter = Titanium.UI.createView({
	height:70,
	backgroundColor:"#fff",
	bottom:0,
	opacity:1.0
});

var lblBar = Titanium.UI.createView({
	height:1,
	width:300,
	border:1,
	borderColor:'#9C9C9C',
	top:0
});

var lblTermsTitle = Titanium.UI.createLabel({
	top:90,
	height:20,
	left:10,
	text:termsLinkText,
	font:{fontSize:16, fontFamily:fontName},
	color:'#000',
	textAlign:'left'
});

var btnAgree = Titanium.UI.createButton({
	width:112,
	height:42,
	bottom:100,
	right:25,
	title: iAgreeText,
	color:'#fff',
	font:{fontSize:18, fontFamily:fontName, fontWeight:'bold'},
	backgroundImage:'images/btnOrange.png',
	backgroundSelectedImage:'images/btnDownOrange.png',
});

var btnBack = Titanium.UI.createButton({
	width:112,
	height:42,
	top:15,
	title: 'Back',
	color:'#fff',
	font:{fontSize:18, fontFamily:fontName, fontWeight:'bold'},
	backgroundImage:'images/btnOrange.png',
	backgroundSelectedImage:'images/btnDownOrange.png',
	visible:false
});

var btnCancelTC = Titanium.UI.createButton({
	width:112,
	height:42,
	bottom:100,
	left:10,
	title: cancelText,
	color:'#000',
	font:{fontSize:18, fontFamily:fontName, fontWeight:'bold'},
	backgroundImage:'images/btnGray.png',
	backgroundSelectedImage:'images/btnDownGray.png',
});

var lblInstructions = Titanium.UI.createLabel({
	top:15,
	height:20,
	text:'Scroll Down to Accept Terms',
	font:{fontSize:16, fontFamily:fontName, fontWeight:'bold'},
	color:'#000',
	textAlign:'center'
});


viewTerms.add(btnAgree);
viewTerms.add(btnCancelTC);

var viewTermsList = Titanium.UI.createTableView({
	top:70,
	bottom:50,
	separatorColor:'#ffffff',
	allowsSelection:false,
	footerView: viewTerms
});

var data = [];
function addRow(idx, type, text)
{
	data[idx] = Ti.UI.createTableViewRow({height:'auto'});
	
	var font = {fontSize:12, fontFamily:fontName}
	if (type == "header") {
		font = {fontSize:14, fontFamily:fontName, fontWeight:'bold'}
	}
	data[idx].add(Ti.UI.createLabel({
		text:text,
		height:'auto',
		width:'auto',
		left:10,
		//right:50,
		top:10,
		font:font,
		//bottom:60,
		color:'#000'
	}));
}

addRow(0, "header","");
addRow(1, "text","PLEASE CAREFULLY READ THE FOLLOWING GREEN DOT MOBILE APPLICATION TERMS OF USE (\"TERMS OF USE\") BEFORE ACTIVATING OR OTHERWISE USING THE GREEN DOT MOBILE APPLICATION AND ITS RELATED SERVICES (COLLECTIVELY, THE \"MOBILE APP\").  BY CLICKING ON THE BUTTON BELOW, PROCEEDING WITH THE MOBILE APP ACTIVATION OR OTHERWISE USING THE MOBILE APP, YOU AGREE TO BE BOUND BY THESE TERMS OF USE AND REPRESENT AND WARRANT THAT YOU HAVE THE RIGHT, AUTHORITY, AND CAPACITY TO ENTER INTO THESE TERMS OF USE.\n\nThe following Terms of Use apply to the Mobile App, operated by Green Dot Corporation (\"Green Dot\", \"we\", \"us\" or \"our\"), and do not modify the terms of the Cardholder Agreement for your Green Dot payment card (\"Card\").  By accessing or using the Mobile App on your mobile device or other equipment (\"Device\"), you acknowledge that you are 18 years of age or older and you have read and agree to be bound by these Terms of Use in their entirety, along with any modifications to these Terms of Use, which are incorporated by reference into these Terms of Use, any additional terms applicable to certain content and features, and all applicable laws, rules and regulations governing your use of the Mobile App. We may add to, delete or change these Terms of Use without notice to you and to the fullest extent under applicable law, your continued use of the Mobile App constitutes your agreement to all such changes.  Unless explicitly stated otherwise, any new features or services that augment or enhance the Mobile App in the future shall be considered part of the Mobile App and subject to these Terms of Use.");
addRow(2, "header", "FEATURES OF THE MOBILE APP");
addRow(3, "text","");
addRow(4, "header","Card Account Information; \"Add Money\" Feature.");
addRow(5, "text", "You are required to create login credentials online at the Green Dot website prior to using the Mobile App.  The login credentials you establish online at the Green Dot website are used to login to the Mobile App.\n\n The Mobile App allows you to view information about your Card account, such as Card balance and transaction history.  The Mobile App also allows you to add money to your Card using a MoneyPak.  See \"ATM and Reload Locations\" below to find out how you can find a MoneyPak retailer near you.\n\nThe Card balance shown by the Mobile App may differ from your records because it may not include transactions in process, outstanding authorizations, or other items.  If you think there is an error in your Card account information, you must telephone or write to us as soon as possible.  For instructions about what to do and how to contact us in case of errors or questions on your Card transactions, please refer to your Cardholder Agreement (also available on the Green Dot website).  It is important that you access your Card information from time to time to ensure that no unauthorized transactions have occurred in your Card account.  For additional transaction history information, you should access your Card account information online at the Green Dot website.");
addRow(6, "header", "ATM and Reload Locations.");
addRow(7, "text", "The locator features of the Mobile App allow you to find ATMs and reload locations where you can purchase a MoneyPak to reload your Card.  These features are dependent on your wireless service and coverage within the area in which you are located at the time you access the Mobile App.  The locator features may not be available in all areas.  Actual distance between your present location and nearest ATM and/or reload location provided by the locator features will vary depending on the area in which you are located (i.e., more locations will be provided if you are located in or near a city versus a rural location).");
addRow(8, "header","Fees.");
addRow(9, "text", "Green Dot does not charge for use of the Mobile App available as of the date you agree to these Terms of Use.  However, if the Mobile App utilizes text messages, standard data and text rates may apply for each text message sent from and received by your Device, as determined by your wireless subscriber agreement with your wireless provider.  You are solely responsible for all data usage and other charges by your wireless provider that accrue from your access to and use of the Mobile App.");
addRow(10, "header", "PRIVACY.");
addRow(11, "text", "1.	You are required to use the login credentials established during activation to use the Mobile App.  Login credentials are not stored on the Device.  Also, Device information (including UDID and your mobile number) may be collected and utilized during installation and use of the Mobile App.\n\n2.	Use and Sharing: Green Dot reserves the right to use login credentials (and location information if you choose to use a Mobile App location-based service): (i) for the specific purpose for which such information was provided; (ii) as disclosed at the time such information is provided; and/or (iii) as disclosed in this Privacy section.  Finally, Green Dot may disclose login credentials (and location information if you choose to use a Mobile App location-based service) in order to: (i) comply with applicable laws; (ii) respond to governmental inquiries; (iii) comply with valid legal process; and (iv) protect our rights or property, the Mobile App and/or other users of this Mobile App.\n\n3.	Third Party Agents: We may employ third parties to perform services on our behalf, such as administering the Mobile App.  Such third parties will have access to login credentials (and your location information if you choose to use a Mobile App location-based service) only to the extent necessary to perform their services, but will not be permitted to use it for any other purpose.\n\n4. 	Security:  Protecting the security of your information is very important to us.  When you transmit login credentials from your Device to our servers, your information is protected by both a \"firewall\" (a combination of computer hardware and software that helps keep unauthorized visitors from accessing information within our computer network) and industry standard SSL (secure socket layer) encryption.  Once we receive your transmission, we will take reasonable precautions to ensure its security on our third party agent's systems.  Unfortunately, no data transmission via a mobile device can be guaranteed to be 100% secure.  As a result, while we strive to protect your information and privacy, we cannot guarantee or warrant the security of any information you disclose or transmit to us via your Device and vice versa and we cannot be responsible for the theft, destruction, or inadvertent disclosure of your information.  By using the Mobile App, you acknowledge this risk when using the Mobile App.\n\n5.	Transfer in Certain Circumstances: In our sole discretion, we may transfer, sell or assign information collected on and through the Mobile App, to one or more third parties, as a result of our sale, merger, consolidation, change in control, transfer of substantial assets, reorganization or liquidation.\n\n6.	Location-Based Services: For Mobile App location-based services (such as the ATM Locator), Green Dot will only use your location if you choose to use the service.  Please be aware that if you regularly authorize others to use your Device with the installed Mobile App, any choices you make with respect to Mobile App location-based services will apply to all users of the Device.  We collect location-based information in order to provide the specific Mobile App location-based service you request.  Except as set forth in these Terms of Use, including, without limitation, as noted in #3 above regarding third party agents, your location will not be shared with third parties without your specific consent.\n\n7.	Privacy Policies:  This Privacy section is in addition to and modifies the Green Dot Privacy Policy and Synovus Privacy Policy provided to you with your Card.  Your use of the Mobile App is also subject to the Green Dot Privacy Policy and the Synovus Bank Privacy Policy (available on the Green Dot website).");
addRow(12, "header", "USE OF THE MOBILE APP");
addRow(13, "text", "Green Dot hereby licenses to you, on a revocable, non-exclusive, non-sublicenseable and otherwise non-transferable basis, and subject to the Terms of Use, the limited right to install, access, and use the Mobile App on a personal Device owned or controlled by you, solely for your own personal, non-commercial use.  All rights not expressly granted to you are reserved by Green Dot.\n\nYou may not modify, copy, distribute, transmit, display, perform, reproduce, publish, license, loan, decompile, reverse engineer, dissassemble, frame, create derivative works from, transfer, or otherwise use in any other way for commercial or public purposes in whole or in part any information, software, products or services obtained from the Mobile App, except for the purposes expressly provided herein, without Green Dot's prior written approval.\n\nUnauthorized use of the Mobile App, including, but not limited to, unauthorized entry into Green Dot's systems, misuse of passwords or misuse of any other information, is strictly prohibited. You agree that you will not access or use the Mobile App, or otherwise engage in any activities related to the Mobile App, contrary to applicable laws or regulations.\n\nYou agree not to provide access to your Device together with your user id and password to others.  You are responsible for all your use of the Mobile App and for ensuring that your use of or access to the Mobile App complies fully with these Terms of Use.  You acknowledge and agree that any use of the Mobile App occurring through the installed Mobile App shall be deemed to be your actions and that Green Dot may rely upon such actions.  You are solely responsible for protecting the security of the installed Mobile App on your Device.");
addRow(14, "header", "SUSPENSION AND TERMINATION");
addRow(15, "text", "If you wish to terminate your use of the Mobile App, please delete the Mobile App according to the application delete functionality associated with your Device.\n\nGreen Dot reserves the right to suspend, discontinue or terminate these Terms of Use and the license hereunder at any time, immediately and without prior notice or obligation to you, and as determined in Green Dot's sole discretion (i) if you violate any part of these Terms of Use, or (ii) for any other reason or no reason.  We may notify you of any such suspension, discontinuance or termination, and upon your receipt of such notice, you will immediately discontinue use of the Mobile App and uninstall the Mobile App from your Device.  You agree that we shall not be liable to you for any suspension, discontinuance or termination of these Terms of Use or the license hereunder.");
addRow(16, "header", "INTERRUPTION OF SERVICE");
addRow(17, "text", "The Mobile App is available through your Device when it is within the operating range of a wireless carrier.  Access to and use of the Mobile App from your Device is subject to transmission limitation, delays, or interruption due to, among other things:  (i) hardware failure (such as failures of your Device, services, networks, telecommunication lines and connections, and other electronic and mechanical equipment); (ii) software failure (such as bugs, errors, viruses, incompatibility of applications, utilities or systems, unreadable codes, irregularities within particular content, or configuration problems); (iii) your wireless service availability and capacity; (iv) government or regulatory restrictions, exchange rulings, court or tribunal orders or other human intervention; or (v) any other cause beyond the control of Green Dot.\n\nYou acknowledge and agree that neither Green Dot nor Synovus Bank will be responsible for or liable to you for: (x) for the capabilities or reliability of any equipment or software used to access the Mobile App; or (y) the unavailability of your wireless service, network delays, limitations on wireless coverage, system outages, or interruption of a wireless connection.");
addRow(18, "header", "DISCLAIMER OF WARRANTIES");
addRow(19, "text", "THE INFORMATION, PRODUCTS AND SERVICES ON THE MOBILE APP ARE PROVIDED ON AN \"AS IS,\" AND \"AS AVAILABLE\" BASIS. YOU AGREE THAT YOUR USE OF AND ACCESS TO THE MOBILE APP ARE AT YOUR SOLE RISK.  NEITHER GREEN DOT NOR SYNOVUS BANK WARRANTS THE INFORMATION OR SERVICES PROVIDED THEREIN OR YOUR USE OF THE MOBILE APP GENERALLY, EITHER EXPRESSLY OR IMPLIEDLY, FOR ANY PARTICULAR PURPOSE, AND EXPRESSLY DISCLAIMS ANY IMPLIED WARRANTIES, INCLUDING BUT NOT LIMITED TO, WARRANTIES OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. GREEN DOT WILL NOT BE RESPONSIBLE FOR ANY LOSS OR DAMAGE THAT COULD RESULT FROM INTERCEPTION BY THIRD PARTIES OF ANY INFORMATION OR SERVICES MADE AVAILABLE TO YOU VIA THE MOBILE APP. GREEN DOT DOES NOT WARRANT THAT THE MOBILE APP WILL WORK ON A DEVICE OR ACROSS THE NETWORK OF A WIRELESS SERVICE PROVIDER.\n\nAlthough the information provided to you on the Mobile App is obtained or compiled from sources we believe to be reliable, Green Dot cannot and does not guarantee the accuracy, validity, timeliness or completeness, security or reliability of any information or data made available to you for any particular purpose.  Neither Green Dot, nor any of its affiliates, directors, officers or employees, nor any Green Dot Licensor (as defined herein), nor any third party vendor (collectively, the \"Green Dot Parties\"), will be liable or have any responsibility of any kind for any loss or damage that you incur in the event of any failure or interruption of the Mobile App, or resulting from the act or omission of any other party involved in making the Mobile App, the data contained herein or the products or services offered on the Mobile App available to you, or from any other cause relating to your access to, inability to access, or use of the Mobile App or these materials, whether or not the circumstances giving rise to such cause may have been within the control of Green Dot or of any vendor providing software or services.\n\nGreen Dot reserves the right, in its sole discretion, without any obligation and without any notice requirement, to change, improve or correct the information, materials and descriptions on the Mobile App and to suspend and/or deny access to the Mobile App for scheduled or unscheduled maintenance, upgrades, improvements or corrections. The information and materials on the Mobile App may contain typographical errors or inaccuracies. Any dated information is published as of its date only, and Green Dot does not undertake any obligation or responsibility to update or amend any such information. Green Dot may discontinue or change any product or service described in or offered on the Mobile App at any time.\n\nYOU UNDERSTAND THAT THERE ARE RISKS ASSOCIATED WITH USING A DEVICE, INCLUDING MOBILE APPLICATIONS ON A DEVICE, AND THAT IN THE EVENT OF THEFT OR LOSS, YOUR CONFIDENTIAL INFORMATION COULD BE COMPROMISED.");
addRow(20, "header", "LIMITATION OF LIABILITY");
addRow(21, "text", "In no event will a Green Dot Party be liable to you or any third party, whether in contract or tort, for any direct, special, indirect, consequential or incidental damages or any other damages of any kind for any breach of these Terms of Use, even if such Green Dot Party has been advised of the possibility thereof. This limitation on liability includes, but is not limited to, loss of use, data, goodwill, business or profits; the transmission of any viruses which may infect a user's equipment; failure of mechanical or electronic equipment or communication lines; telephone or other interconnect problems (e.g., you cannot access your internet service provider); unauthorized access; theft; operator errors; strikes or other labor problems or any force majeure. Green Dot cannot and does not guarantee continuous, uninterrupted or secure access to the Mobile App.\n\nIn addition, notwithstanding anything contrary herein, although Green Dot may take reasonable precautions to protect the Mobile App and avoid deletion, corruption or unauthorized modification or access of or to the Mobile App, and to provide the Mobile App error-free or uninterrupted, we make no representation and warranty that our efforts will be successful at all times, and we specifically disclaim all liability whatsoever with respect to our failure to protect the Mobile App or provide the Mobile App error-free or uninterrupted.");
addRow(22, "header", "PROPRIETARY RIGHTS");
addRow(23, "text", "All right, title and interest in and to the Mobile App and any content contained herein is and will remain the exclusive property of Green Dot and/or Green Dot Licensors , except as otherwise stated. The Mobile App is protected by copyrights, trademarks, service marks, and/or other proprietary and intellectual property rights and laws of the United States and other countries.  You agree to abide by all applicable proprietary rights laws, as well as any additional copyright notices or restrictions contained in these Terms of Use or in the Mobile App.  If you copy or download any information or software from the Mobile App, you agree that you will not remove or obscure any copyright or other notices or legends contained in any such information.\n\nThe Mobile App may contain components licensed from Green Dot's licensors and content and data providers (collectively, \"Green Dot Licensors\"), which components may enable the Mobile App to perform certain functions.  All rights in any third-party components or data, including, without limitation, all ownership rights, are reserved and remain with the respective Green Dot Licensors.");
addRow(24, "header", "INDEMNIFICATION");
addRow(25, "text", "You agree to indemnify, defend and hold harmless the Green Dot Parties from and against any actual or alleged claims, demands, causes of action, judgments, damages, losses, liabilities, and all costs and expenses of defense (including, without limitation, reasonable attorneys' and other legal fees and costs) arising out of or relating to: (i) your violation of these Terms of Use or any law, rule or regulation; and (ii) your loss or the interception of any data or account information. You will cooperate as fully and reasonably as required by Green Dot in the defense of any claim.  Green Dot reserves the right to assume the exclusive defense and control of any matter subject to indemnification by you, and you will not in any event settle any claim without the prior written consent of Green Dot.");
addRow(26, "header", "GOVERNING LAW");
addRow(27, "text", "These Terms of Use shall be exclusively governed by and construed in accordance with the laws of the State of California excluding conflicts of law rules. Any dispute arising from these Terms of Use shall be resolved in the state or federal courts residing in Los Angeles, California and you irrevocably agree to the jurisdiction of such courts.");
addRow(28, "header", "MISCELLANEOUS");
addRow(29, "text", "Assignment: You may not assign these Terms of Use without Green Dot's prior written consent.  Entire Agreement: These Terms of Use represent the entire agreement between you and us in connection with the Mobile App, which may only be amended as described in these Terms of Use.  If any provision of these Terms of Use are deemed unlawful, void or for any reason unenforceable, then that provision shall be deemed severable from these Terms of Use and shall not affect the validity and enforceability of any remaining provisions. Export Control Laws: You acknowledge that the laws and regulations of the United States and other countries may restrict the export and re-export of the Mobile App.  You agree that you will not export or re-export the Mobile App in any form or to any recipient whether inside or outside of the United States in violation of applicable United States and foreign law.  Additional Provisions:  The Mobile App is void where prohibited by law.  The failure to enforce any term of these Terms of Use on one occasion shall not prevent enforcement on any other occasion or the enforcement of any other term.  Headings and captions shall not be considered included for purposes of interpretation or application hereof, but are for convenience only.  Some states do not allow limitation of implied warranties or the exclusion or limitation of certain damages.  If any provision is found to be void or unenforceable, the remaining provisions will remain in effect.");
addRow(30, "header", "CONTACT US");
addRow(31, "text", "Green Dot Customer Service, P.O. Box 1187, Monrovia, California 91017 or you can call us at 1-866-795-7597.  If you would like a copy of these Terms of Use, please call or write to us.\n\nCopyright 2011 Green Dot Corporation. All rights reserved.\n\n");

//viewTermsList.footerView = viewTerms;
viewTermsList.data = data;


viewFooter.add(lblBar);
viewFooter.add(btnBack);
viewFooter.add(lblInstructions);

winTermsAndConditions.add(viewTermsList);
winTermsAndConditions.add(viewHeaderTerms);
winTermsAndConditions.add(viewFooter);
