/**
 * @author mweidner
 */
var stateList = [
	'Alabama',	'Alaska', 'Arizona', 'Arkansas', 'California', 'Colorado', 'Connecticut', 'Delaware',
	'District of Columbia',	'Florida', 'Georgia', 'Hawaii', 'Idaho', 'Illinois', 'Indiana', 'Iowa',	
	'Kansas', 'Kentucky', 'Louisiana', 'Maine', 'Maryland',	'Massachusetts', 'Michigan', 'Minnesota',	
	'Mississippi', 'Missouri', 'Montana', 'Nebraska', 'Nevada', 'New Hampshire', 'New Jersey', 'New Mexico',	
	'New York',	'North Carolina', 'North Dakota', 'Ohio', 'Oklahoma', 'Oregon', 'Pennsylvania',	'Rhode Island',	
	'South Carolina', 'South Dakota', 'Tennessee', 'Texas', 'Utah',	'Vermont', 'Virginia', 'Washington',	
	'West Virginia', 'Wisconsin', 'Wyoming'
];
var stateAbrList = [
'AL','AK','AZ','AR','CA','CO','CT','DE',
'DC','FL','GA','HI','ID','IL','IN','IA',
'KS','KY','LA','ME','MD','MA','MI','MN',
'MS','MO','MT','NE','NV','NH','NJ','NM',
'NY','NC','ND','OH','OK','OR','PA','RI',
'SC','SD','TN','TX','UT','VT','VA','WA',
'WV','WI','WY'
];

if (Titanium.Platform.name == 'iPhone OS') {
	var activityIndBig = Titanium.UI.createActivityIndicator({
		style:Titanium.UI.iPhone.ActivityIndicatorStyle.BIG,
		font: {
			fontSize: 16,
			fontWeight: 'bold',
			fontFamily: fontName
		},
		height: 30,
		width: 200,
		top:50	
	});
	var viewActivityInd = Titanium.UI.createView({
		height: 150,
		width: 150
	});
	var viewFadeScreen = Titanium.UI.createView({
		height: platformHeight,
		width:  platformWidth,
		backgroundColor:'#606060',
		opacity: 0.6
	});
	viewActivityInd.add(activityIndBig);
	activityIndBig.show();
}

var activityInd = Titanium.UI.createActivityIndicator({
	message: 'LOADING...',
	font: {
		fontSize: 16,
		fontWeight: 'bold',
		fontFamily: fontName
	},
	height: 30,
	width: 30
});

function formatNegativeAmount(accountBalance) {
	var s = accountBalance;
	if (s.indexOf("-")	== -1) {
		return "$"+ accountBalance;
	} else {
		return accountBalance.replace("-", "-$");
	}
}
// alert box before leaving the app to get directions
function getDirections(sourceAddr, dStreet, dCity, dState, dZip) {
	var buttons = ['OK', 'Cancel'];
	var getDirectionsAlert = getAlert('Leave Green Dot Mobile to get directions?','',  buttons);
	
	getDirectionsAlert.addEventListener('click', function(e) {
		if (e.index == 0) {
			Ti.Platform.openURL('http://maps.google.com/maps?saddr='+ sourceAddr + 
				'&daddr=' + dStreet + ',+' + dCity,+ ',+' + dState,+ ',+' + dZip+'&dirflg=d');
		} 
	});
}

// alert box before leaving the app to call customer care
function callCustomerCare() {
	var buttons = ['OK', 'Cancel'];
	var callCareAlert = getAlert('Leave Green Dot Mobile to call Customer Care?','', buttons);

	callCareAlert.addEventListener('click', function(e) {
		if (e.index == 0) {
			Titanium.Platform.openURL('tel:'+18667957597);
		} 
	});
}

function randomString(length){
    var chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz";
    var string_length = length;
    var randomstring = '';
    for (var i = 0; i < string_length; i++) {
        var rnum = Math.floor(Math.random() * chars.length);
        randomstring += chars.substring(rnum, rnum + 1);
    }
    return randomstring;
}

function IsNumeric(sText)
{
    var ValidChars = "0123456789";
    var IsNumber = true;
    var Char;
    for (i = 0; i < sText.length; i++)
    {
                    Char = sText.charAt(i);
                    if (ValidChars.indexOf(Char) == -1)
                    {
                                    IsNumber = false;
                                    break;
                    }
    }
    return IsNumber;
}

var lastScreenRedirect;
function overrideLastScreen(screen) {
	lastScreenRedirect = screen;
}

var boolInternalRedirect;
function overrideInternalRedirect(internalRedirect) {
	boolInternalRedirect = internalRedirect;
}

function redirect(targetWindowName, eventToFire, initParameters, boolSkipHistory, backWindowName, backEventToFire, backInitParameters) {
	if (boolSkipHistory == null) {
		boolSkipHistory = false;
	}
	
	if (initParameters == null) {
		initParameters = {};
	}
	
	if (initParameters.backButton == null) {
		initParameters.backButton = false;
	}
	
	// Reset this, then we can check if the eventToFire handler sets it
	lastScreenRedirect = null;
	boolInternalRedirect = false;
	
	// Clear out the old timeout (if it exists) and set a new timeout
	if (msUserTimeoutObj != null) {
		myClearTimeout(msUserTimeoutObj);
	}
	msUserTimeoutObj = mySetTimeout("logout()", msUserTimeout);
	
	// Open up the new window via open or init
	var boolContinueRedirect = true;
	if (eventToFire != null && eventToFire != "") {
		boolContinueRedirect = windowsMap[targetWindowName][eventToFire](initParameters);
	} else {
		boolContinueRedirect = windowsMap[targetWindowName].initialize({});
	}
	
	if (boolContinueRedirect) {
		// We need to setup the history entry
		if (!boolSkipHistory) {
			var historyEntry = {};
			if (backWindowName != null) {
				backInitParameters.backButton = true;
				
				historyEntry.target = backWindowName;
				historyEntry.handler = backEventToFire;
				historyEntry.args = backInitParameters;
			} else {
				initParameters.backButton = true;
				
				//historyEntry.target = Titanium.App.Properties.getString("lastScreen");
				historyEntry.target = targetWindowName;
				historyEntry.handler = "initialize";
				historyEntry.args = initParameters;
			}
			history.push(historyEntry);
		}
		
		if (boolInternalRedirect == false) {
			
			// Close out the previous window, but only if it is set already
			for (var key in windowsMap) {
  				if (windowsMap.hasOwnProperty(key)) {
    				windowsMap[key].hide();
					windowsMap[key].visible = false;
  				}
			}
			
			// If lastScreenRedirect is set, then we know that we overrode the last screen in the eventToFire
			if (lastScreenRedirect == null) {
				Titanium.App.Properties.setString("lastScreen", targetWindowName);
			}
			else {
				Titanium.App.Properties.setString("lastScreen", lastScreenRedirect);
			}
			
			hideActivityInd();
			
			windowsMap[targetWindowName].show();
			windowsMap[targetWindowName].visible = true;
			
		} else {
			
		}
	}
}

var history = [];
function goBack() {
	if (history.length >= 2) {
		history.pop();
		var historyEntry = history[history.length - 1];
		if (historyEntry != null) {
			redirect(historyEntry.target, historyEntry.handler, historyEntry.args, true);
		}
	}
}

function goHome() {
	history = [];
	if(isLoggedIn == false) {
		redirect("loginScreen", null, null);
	} else {
		redirect("accountBalanceScreen", null, null);
	}	
}

function timeoutObject(){
    this.flag = true;
}

function mySetTimeout(callback, time){
    var myCallback = callback;
    if (typeof callback == 'string') {
        myCallback = function(){
            eval(callback);
        };
    }
    var timerobj = new timeoutObject();
    setTimeout(function(){
        if (timerobj.flag) {
            myCallback();
        }
    }, time);
    return timerobj;
}

function myClearTimeout(timer){
    timer.flag = false;
}

function logout(){
	if (isLoggedIn) {
		
		// Reset cached data:
		msWebSkinId = 0;
		msContext = null;
		msCipher = null;
		msCard = null;
		msCardId = null;
		msWaivers = null;
		msBillCycleId = null;
		msTransactions = null;
		msLocations = null;
		msLocationsRawResult = null;
		msUserRegion = null;
		msUserZip = null;
		
		// Clear the password out:
		txtPassword.value = "";
		
		isLoggedIn = false;
		history = [];
		redirect("loginScreen", "initialize", {action:"logout"});
	}
}

function getAlert(msgText, msgTitle, btnNames) {
	var aAlert;
	if(btnNames != null) {	
		if(btnNames.length == 1) {
			if (Titanium.Platform.name == 'iPhone OS') {
				alert(msgText);
			} else if (Ti.Platform.name == 'android') {
				if (msgTitle == null) {
					msgTitle = "Alert";
				}
				var a = Ti.UI.createAlertDialog();
				winHub.add(a);
				a.message = msgText;
				a.title = msgTitle;	
				a.buttonNames = ['OK'];
				a.show();
			}	
		} else {
			if (Titanium.Platform.name == 'iPhone OS') {
				aAlert = Titanium.UI.createAlertDialog({
					title: msgTitle,
					message: msgText,
					buttonNames: btnNames,
					cancel: 1,				
				});
				aAlert.show();
				 
			} else if (Ti.Platform.name == 'android') {
				if (msgTitle == null) {
					msgTitle = "Alert";
				}
				var a = Ti.UI.createAlertDialog();
				winHub.add(a);
				a.message = msgText;
				a.title = msgTitle;	
				a.buttonNames = btnNames;
				a.cancel = 1;
				a.show();
				aAlert = a;
			}			
		}
	} else {
		if (Titanium.Platform.name == 'iPhone OS') {
				alert(msgText);
		} else if (Ti.Platform.name == 'android') {
			if (msgTitle == null) {
				msgTitle = "Alert";
			}
			var a = Ti.UI.createAlertDialog();
			winHub.add(a);
			a.message = msgText;
			a.title = msgTitle;	
			a.buttonNames = ['OK'];
			a.show();
		}	
	}
	return aAlert;
	
}

/**
 * This provides AES/CBC/PCKS5Padding encryption using the provided cipher
 * @param String toEncrypt - plaintext 
 * @param String cipher - the cipher, guid as a string
 * @return The base64 encoded result
 */
function encrypt(toEncrypt, cipher) {
	var uuid = new UUID(cipher);
	var keyBytes = uuid._byteArray;
	var ivBytes = uuid._byteArray;
	var plainStringBytes = cryptoHelpers.convertStringToByteArray(toEncrypt);
	
	var byteArrayResult = slowAES.encrypt(plainStringBytes, slowAES.modeOfOperation.CBC, keyBytes, ivBytes);
	var base64EncodedResult = cryptoHelpers.base64.encode_line(byteArrayResult).trim();
	return base64EncodedResult;
}

function formatDate(dateString) {
	var returnDate = null;
	if (dateString == null || dateString == "") {
		returnDate = "";
	}
	else 
	{
		// year-month-day
		var dateParts = dateString.split("T");
		var dayParts = dateParts[0].split("-");
		returnDate = dayParts[1] + "-" + dayParts[2] + "-" + dayParts[0];
	}
	return returnDate;
}

function formatCurrency(num){
    num = num.toString().replace(/\$|\,/g, "");
    if (isNaN(num)) 
        num = "0";
    num = Math.floor(num * 100 + 0.50000000001);
    cents = num % 100;
    num = Math.floor(num / 100).toString();
    if (cents < 10) 
        cents = "0" + cents;
    for (var i = 0; i < Math.floor((num.length - (1 + i)) / 3); i++) 
        num = num.substring(0, num.length - (4 * i + 3)) + ',' + num.substring(num.length - (4 * i + 3));
    return num + '.' + cents;
}

/**
 * 
 * @param String toDigest - the string to create a digest of
 * @param byteArray keyByteArray - the key as a byte array
 */
function hmacSHA256(toDigest, keyByteArray) {
	HMAC_SHA256_init(keyByteArray);
	HMAC_SHA256_write(toDigest);
	digest = HMAC_SHA256_finalize();
	base64Digest = cryptoHelpers.base64.encode_line(digest);
	return base64Digest;	
}

function hmacSHA256Header(headers, applicationToken, clientToken) {
	var rv = "";
	
	var headerString = "";
	headerString += "X-GDC-ApplicationID : " + headers["X-GDC-ApplicationID"].trim() + "\r\n";
	headerString += "X-GDC-DeviceID : " + headers["X-GDC-DeviceID"].trim() + "\r\n";
	headerString += "X-GDC-MessageID : " + headers["X-GDC-MessageID"].trim() + "\r\n";
	headerString += "X-GDC-Method : " + headers["X-GDC-Method"].trim() + "\r\n";
	headerString += "X-GDC-SessionToken : " + headers["X-GDC-SessionToken"].trim() + "\r\n";
	headerString += "X-GDC-Timestamp : " + headers["X-GDC-Timestamp"].trim() + "\r\n";
	headerString += "X-GDC-Version : " + headers["X-GDC-Version"].trim() + "\r\n";
	
	if ("1" == headers["X-GDC-Method"].trim()) {
		var uuid = new UUID(applicationToken.trim());
		HMAC_SHA256_init(uuid._byteArray);
		HMAC_SHA256_write(headerString);
		digest = HMAC_SHA256_finalize();
		rv = cryptoHelpers.base64.encode_line(digest);
	} else {
		// assume method 2 -- should only BE method 2
		var appUUID = new UUID(applicationToken.trim());
		var ctUUID = new UUID(clientToken.trim());
		var appUUIDByteArray = appUUID._byteArray;
		var ctUUIDByteArray = ctUUID._byteArray;
		var keyByteArray = appUUIDByteArray.concat(ctUUIDByteArray);
		
		HMAC_SHA256_init(keyByteArray);
		HMAC_SHA256_write(headerString);
		digest = HMAC_SHA256_finalize();
		rv = cryptoHelpers.base64.encode_line(digest);
	}
	return rv;
	
}

