/**
 * @author mweidner
 */

function runPreSignOn() {
	
	var d = new Date();
	var curr_date = d.getDate();
	var curr_month = d.getMonth();
	// Month is a zero index base
	curr_month++;
	var curr_year = d.getFullYear();
	var curr_hour = d.getHours();
	var curr_min = d.getMinutes();
	var curr_sec = d.getSeconds();
	var curr_msec = d.getMilliseconds();
	
	// Fix the date objects to have leading zero's if needed
	if (curr_date.length == 1) { cur_date = "0" + curr_date; }
	if (curr_month.length == 1) { curr_month = "0" + curr_month; }
	if (curr_hour.length == 1) { curr_hour = "0" + curr_hour; }
	if (curr_min.length == 1) { curr_min = "0" + curr_min; }
	if (curr_msec.length == 1) { curr_msec = "0" + curr_msec; }

	var headers = {};
	headers["X-GDC-ApplicationID"] = msApplicationId;
	if (msDebug) {
		headers["X-GDC-DeviceID"] = DebugVars.id;
	} else {
		headers["X-GDC-DeviceID"] = Ti.Platform.id;
	}
	headers["X-GDC-MessageID"] = randomString(12);
	headers["X-GDC-Method"] = "1";
	headers["X-GDC-SessionToken"] = "";
	headers["X-GDC-Timestamp"] = curr_year + "-" + curr_month + "-" + curr_date + "T" + curr_hour + ":" + curr_min + ":" + curr_sec + "." + curr_msec;
	headers["X-GDC-Version"] = msProviderVersion;
	 
	if (Ti.Platform.address != null) {
		headers["X-GDC-ClientIP"] = Ti.Platform.address;
	}
	headers["X-GDC-Carrier"] = "";
	headers["X-GDC-Digest"] = hmacSHA256Header(headers, msApplicationToken, null);
	
    sendJSONRequest(msGDRESTPreSignOnEndpoint, null, "preSignOnSuccessHandler", "preSignOnErrorHandler", headers);
    
}

Titanium.App.addEventListener('preSignOnSuccessHandler', function(e){

});

Titanium.App.addEventListener('preSignOnErrorHandler', function(e){

});

var iNetworkErrorCounter = 0;

function sendJSONRequest(endpoint, requestObj, successHandler, errorHandler, headers) {
	//Ti.API.info(JSON.stringify(requestObj));
	//Ti.API.info(JSON.stringify(headers));
	
	if (!Ti.Network.online) {
        getAlert('You are not currently connected to a network, a network connection is required by this application!');
		return;
    }
	
	activityInd.show();
	
    var xhr = Ti.Network.createHTTPClient();
	xhr.validatesSecureCertificate = true;
	var postMethod = "POST";
	if (requestObj == null) {
		postMethod = "GET";
	}
    
    xhr.onload = function(){
        try {
            var resp = eval('(' + this.responseText + ')');
            
            //var status = resp.AuthenticateMobileUserClientWalletResult.Status;
			status = "0"; // Have to hard code this for now because we don't know the class at this point
            if (status == 0) {
                // Good response back
                Titanium.App.fireEvent(successHandler, resp);
            }
            else {
				// Error response back
                Titanium.App.fireEvent(errorHandler, resp);
            }
			
			// This is a successful network call (even if the result is an error), reset the counter
			iNetworkErrorCounter = 0;
        } 
        catch (e) {
			activityInd.hide();
			hideActivityInd();
			
			iNetworkErrorCounter++;
			
			if (iNetworkErrorCounter <= 2) {
				getAlert(networkTmpError);
			} else {
				getAlert(networkPersistantError);
				logout();
			}
        }
    };
    xhr.onerror = function(e){
		//alert("Network Error Thrown!");
		activityInd.hide();
		hideActivityInd();
			
		
		iNetworkErrorCounter++;
			
		if (iNetworkErrorCounter <= 2) {
			getAlert(networkTmpError);
		} else {
			getAlert(networkPersistantError);
			logout();
		}
		
    };
    xhr.onreadystatechange = function(){
        if (this.readyState == 0 || this.readyState == 1 || this.readyState == 2 || this.readyState == 3) {
            showActivityInd();
			activityInd.show();
        }
        if (this.readyState == 4) {
            activityInd.hide();
			hideActivityInd();
        }
    };
    xhr.open(postMethod, endpoint, false);
    xhr.setTimeout(30000);
    xhr.setRequestHeader("Content-Type", "application/json");
	if (headers != null) {
		for (var key in headers) {
			if (headers.hasOwnProperty(key)) {
				xhr.setRequestHeader(key, headers[key]);
			}
		}
	}
	var postData = "";
	if (requestObj != null) {
		postData = JSON.stringify(requestObj);
	}
    xhr.send(postData);
}

var boolActShowing = false;
function hideActivityInd() {
	if (boolActShowing == false) {
		return;
	}
	//Ti.API.info("Finished Loading...");
	if(Ti.Platform.name == 'iPhone OS') {
		winHub.remove(viewFadeScreen);
		winHub.remove(viewActivityInd);
	}

	
	boolActShowing = false;
}

function showActivityInd() {
	if (boolActShowing == true) {
		return;
	}
	if (Ti.Platform.name == 'iPhone OS') {
		winHub.add(viewFadeScreen);
		winHub.add(viewActivityInd);
	}
	boolActShowing = true;
}
